#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define yyparse NFSv4yyparse
#define yylex NFSv4yylex
#define yyerror NFSv4yyerror
#define yychar NFSv4yychar
#define yyval NFSv4yyval
#define yylval NFSv4yylval
#define yydebug NFSv4yydebug
#define yynerrs NFSv4yynerrs
#define yyerrflag NFSv4yyerrflag
#define yyss NFSv4yyss
#define yyssp NFSv4yyssp
#define yyvs NFSv4yyvs
#define yyvsp NFSv4yyvsp
#define yylhs NFSv4yylhs
#define yylen NFSv4yylen
#define yydefred NFSv4yydefred
#define yydgoto NFSv4yydgoto
#define yysindex NFSv4yysindex
#define yyrindex NFSv4yyrindex
#define yygindex NFSv4yygindex
#define yytable NFSv4yytable
#define yycheck NFSv4yycheck
#define yyname NFSv4yyname
#define yyrule NFSv4yyrule
#define yysslim NFSv4yysslim
#define yystacksize NFSv4yystacksize
#define YYPREFIX "NFSv4yy"
#line 5 "util/parser/parser.y"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "GLOBALS.h"                    /* Contains the custom Linux_SystemSetting classname _SETTINGCLASSNAME */

#include "cmpidt.h"                     /* Contains CIM type definitions */
static CMPIType propertytype;                  /* CIM type of the current property */

extern FILE * NFSv4yyout;
extern char * NFSv4comments;

/* DEFINE ANY GLOBAL VARS HERE */
static char * secname;				/* String to construct security property name */
static int true = 1;				

static startinstance (char * classname);
static endinstance();
static startproperty (char * name, CMPIType type);
static endproperty();
static setvalue (void * value);

#line 30 "util/parser/parser.y"
typedef union {
   CMPIBoolean          boolean;
   CMPIChar16           char16;
   CMPIUint8            uint8;
   CMPIUint16           uint16;
   CMPIUint32           uint32;
   CMPIUint64           uint64;
   CMPISint8            sint8;
   CMPISint16           sint16;
   CMPISint32           sint32;
   CMPISint64           sint64;
   CMPIReal32           real32;
   CMPIReal64           real64;
   /* Note - we override the CIM definition of string and dateTime to make these data types
      easier to handle in the lexer/parser. Both are instead implemented as simple text strings. */
   char *               string;
   char *               dateTime;
} YYSTYPE;
#line 85 "parser.c"
#define YYERRCODE 256
#define PSEUDO 257
#define SECURITY 258
#define SECURITY_VALUE 259
#define PERMISSION 260
#define PATHNAME 261
const short NFSv4yylhs[] = {                                        -1,
    0,    0,    0,    3,    1,    2,    5,    2,    4,    4,
    4,    4,    6,    7,    7,    8,
};
const short NFSv4yylen[] = {                                         2,
    0,    1,    2,    0,    3,    2,    0,    6,    1,    3,
    5,    7,    1,    1,    3,    1,
};
const short NFSv4yydefred[] = {                                      0,
    4,    0,    0,    0,    3,    0,    5,    0,    6,    0,
    7,    0,    9,    0,    8,    0,   13,    0,    0,   10,
    0,   16,    0,    0,    0,   11,    0,    0,   15,    0,
   12,
};
const short NFSv4yydgoto[] = {                                       2,
    3,    7,    4,   15,   12,   18,   23,   24,
};
const short NFSv4yysindex[] = {                                   -258,
    0,    0, -258,  -33,    0,  -41,    0,  -50,    0, -249,
    0,  -40,    0, -252,    0,  -48,    0,  -39, -245,    0,
 -243,    0,  -25,  -38,  -44,    0, -245, -245,    0,  -23,
    0,
};
const short NFSv4yyrindex[] = {                                     19,
    0,    0,   19,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -20,    0,    0,    0,    0,    0,    0,
    0,
};
const short NFSv4yygindex[] = {                                     20,
    0,    0,    0,    0,    0,    0,  -18,    0,
};
#define YYTABLESIZE 216
const short NFSv4yytable[] = {                                       9,
   13,   20,    1,   14,   21,   16,    6,   17,   29,   30,
   10,   11,   19,   22,   25,   26,   28,   31,    1,   27,
   14,    0,    5,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    8,
};
const short NFSv4yycheck[] = {                                      41,
   41,   41,  261,   44,   44,  258,   40,  260,   27,   28,
   61,  261,   61,  259,  258,   41,   61,   41,    0,   58,
   41,   -1,    3,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 261
#if YYDEBUG
const char * const NFSv4yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,"'='",0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"PSEUDO",
"SECURITY","SECURITY_VALUE","PERMISSION","PATHNAME",
};
const char * const NFSv4yyrule[] = {
"$accept : stanzas",
"stanzas :",
"stanzas : stanza",
"stanzas : stanza stanzas",
"$$1 :",
"stanza : PATHNAME $$1 options",
"options : '(' ')'",
"$$2 :",
"options : '(' PSEUDO '=' PATHNAME $$2 permsec",
"permsec : ')'",
"permsec : ',' permission ')'",
"permsec : ',' SECURITY '=' security_values ')'",
"permsec : ',' permission ',' SECURITY '=' security_values ')'",
"permission : PERMISSION",
"security_values : security_value",
"security_values : security_value ':' security_values",
"security_value : SECURITY_VALUE",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 133 "util/parser/parser.y"
/* USER SUBROUTINE SECTION */

/* DO NOT CHANGE ANYTHING BELOW THIS LINE */

/* XML CIM output subroutines */

static startinstance (char * classname)
/* Start an XML CIM instance specification */
{
   fprintf(NFSv4yyout, "<INSTANCE CLASSNAME=\"%s\">\n", classname);
}

static endinstance()
/* End XML CIM instance */
{
   fprintf(NFSv4yyout, "</INSTANCE>\n");
}

static startproperty (char * name, CMPIType type)
/* Start an XML CIM property specification */
{
   fprintf(NFSv4yyout, " <PROPERTY NAME=\"%s\"", name);
   propertytype = type;
   switch(propertytype) {
      case CMPI_boolean:        fprintf(NFSv4yyout, " TYPE=\"boolean\""); break;
      case CMPI_char16:         fprintf(NFSv4yyout, " TYPE=\"char16\""); break;
      case CMPI_uint8:          fprintf(NFSv4yyout, " TYPE=\"uint8\""); break;
      case CMPI_sint8:          fprintf(NFSv4yyout, " TYPE=\"sint8\""); break;
      case CMPI_uint16:         fprintf(NFSv4yyout, " TYPE=\"uint16\""); break;
      case CMPI_sint16:         fprintf(NFSv4yyout, " TYPE=\"sint16\""); break;
      case CMPI_uint32:         fprintf(NFSv4yyout, " TYPE=\"uint32\""); break;
      case CMPI_sint32:         fprintf(NFSv4yyout, " TYPE=\"sint32\""); break;
      case CMPI_uint64:         fprintf(NFSv4yyout, " TYPE=\"uint64\""); break;
      case CMPI_sint64:         fprintf(NFSv4yyout, " TYPE=\"sint64\""); break;
      case CMPI_real32:         fprintf(NFSv4yyout, " TYPE=\"real32\""); break;
      case CMPI_real64:         fprintf(NFSv4yyout, " TYPE=\"real64\""); break;
      case CMPI_string:         fprintf(NFSv4yyout, " TYPE=\"string\""); break;
      case CMPI_dateTime:       fprintf(NFSv4yyout, " TYPE=\"dateTime\""); break;
      default:                  fprintf(stderr, "Unknown property type CMPIType=%d\n", propertytype);
                                exit(1);
                                break;
   }
   fprintf(NFSv4yyout, ">");
}

static endproperty()
/* End XML CIM property */
{
   fprintf(NFSv4yyout, " </PROPERTY>\n");
}

static setvalue (void * value)
/* Set an XML CIM value */
{
   fprintf(NFSv4yyout, " <VALUE>");
   switch(propertytype) {
      case CMPI_boolean:        fprintf(NFSv4yyout, *((CMPIBoolean *)value)? "true":"false"); break;
      case CMPI_char16:         fprintf(NFSv4yyout, "%c", *((CMPIChar16 *)value)); break;
      case CMPI_uint8:          fprintf(NFSv4yyout, "%d", *((CMPIUint8 *)value)); break;
      case CMPI_sint8:          fprintf(NFSv4yyout, "%d", *((CMPISint8 *)value)); break;
      case CMPI_uint16:         fprintf(NFSv4yyout, "%d", *((CMPIUint16 *)value)); break;
      case CMPI_sint16:         fprintf(NFSv4yyout, "%d", *((CMPISint16 *)value)); break;
      case CMPI_uint32:         fprintf(NFSv4yyout, "%d", *((CMPIUint32 *)value)); break;
      case CMPI_sint32:         fprintf(NFSv4yyout, "%d", *((CMPISint32 *)value)); break;
      case CMPI_uint64:         fprintf(NFSv4yyout, "%d", *((CMPIUint64 *)value)); break;
      case CMPI_sint64:         fprintf(NFSv4yyout, "%d", *((CMPISint64 *)value)); break;
      case CMPI_real32:         fprintf(NFSv4yyout, "%f", *((CMPIReal32 *)value)); break;
      case CMPI_real64:         fprintf(NFSv4yyout, "%f", *((CMPIReal64 *)value)); break;
      case CMPI_string:         fprintf(NFSv4yyout, "%s", (char *)value); break;
      case CMPI_dateTime:       fprintf(NFSv4yyout, "%s", (char *)value); break;
      default:                  fprintf(stderr, "Unknown property type CMPIType=%d\n", propertytype);
                                exit(1);
                                break;
   }
   fprintf(NFSv4yyout, "</VALUE>");
}


/* yacc parser subroutines */

int NFSv4yyparsefile(FILE * infile, FILE * outfile)
{
   NFSv4yyrestart(infile);
   NFSv4yyout = outfile;
   return(NFSv4yyparse());
}

int main ()
{
   return NFSv4yyparse();
}

#line 329 "parser.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
#line 70 "util/parser/parser.y"
{
				startinstance(_SETTINGCLASSNAME);
				startproperty("SettingID",CMPI_string);
				setvalue(yyvsp[0].string);
				endproperty();
				startproperty("Directory",CMPI_string);
				setvalue(yyvsp[0].string);
				endproperty();
				free(yyvsp[0].string);
				}
break;
case 5:
#line 80 "util/parser/parser.y"
{
                                /* Check if there are any comments pending */
                                if (NFSv4comments != NULL) {
                                   startproperty("Description",CMPI_string);
                                   /* Strip off the trailing newline */
                                   if (NFSv4comments[strlen(NFSv4comments)-1] == '\n') NFSv4comments[strlen(NFSv4comments)-1] = '\0';
                                   setvalue(NFSv4comments);
                                   endproperty();
                                   free(NFSv4comments); NFSv4comments = NULL;
                                }
				endinstance();
				}
break;
case 7:
#line 95 "util/parser/parser.y"
{
				startproperty("PseudoPath",CMPI_string);
				setvalue(yyvsp[0].string); free(yyvsp[0].string);
				endproperty();
				}
break;
case 13:
#line 109 "util/parser/parser.y"
{
				startproperty("Permission",CMPI_string);
                                setvalue(yyvsp[0].string); free(yyvsp[0].string);
                                endproperty();
				}
break;
case 16:
#line 121 "util/parser/parser.y"
{
				secname = malloc(strlen(yyvsp[0].string)+10);
				sprintf(secname, "Security_%s", yyvsp[0].string);
				free(yyvsp[0].string);
				startproperty(secname,CMPI_boolean);
				setvalue(&true);
				free(secname);
				endproperty();
				}
break;
#line 580 "parser.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
